﻿/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package
{
	import com.debug.Out;
	import com.utils.MathUtils;
	

	
	
	import com.as3facile.DefaultButton;
	import com.actionscriptfacile.ui.text.UITextField;
	
	
	import flash.events.Event;
	import flash.display.Sprite;
	import flash.events.MouseEvent;	



	public class Main extends Sprite
	{
	
		/**
		 * Constructeur.
		 * 
		 */
		public function Main()
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}

		/**
		 * Démarrage de l'application.
		 * définit le nombre d'images par secondes dans les paramètres de compilation
		 * -default-frame-rate 40
		 * 
		 */
		private function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);
			
			
			// création d'un bouton
			var oBtnStart:DefaultButton = new DefaultButton();
			oBtnStart.getObject().label = "C'est Parti !";
			oBtnStart.getObject().x = (stage.stageWidth - oBtnStart.getObject().width ) / 2;
			oBtnStart.getObject().y = 20;
			oBtnStart.getObject().addEventListener ( MouseEvent.CLICK, onStartRound );
			this.addChild(oBtnStart);
			
			
			// préparation d'une sortie Trace rapide pour l'application
			var oTextDebug:UITextField = this.addText("Cliquez sur le bouton ci-dessus pour lancer les arrondis.\n");
			oTextDebug.x = 10;
			oTextDebug.y = oBtnStart.getObject().y + oBtnStart.getObject().height + 20;
			this.addChild(oTextDebug);
			
			Out.stage = stage;
			Out.textField = oTextDebug;
			Out.maxLength = 5333;// longueur maximum
		}
		
		
		
		/**
		 * Nouveau calcul.
		 * 
		 */
		private function onStartRound(event : MouseEvent) : void
		{
			var nVal1 : int = MathUtils.randomInt(50, 234);
			var nVal2 : Number = MathUtils.randomNumber(0.34, 33.4);
			var nResult:Number = nVal1 / nVal2;
			
			Out.trace("Nombre avec toutes les décimales : "+ nResult );
			Out.trace("Arrondi sans décimale : "+ this.mathRounding(nResult) );
			Out.trace("Arrondi avec 2 décimales : "+ this.mathRounding(nResult, 2) );
			Out.trace("Arrondi avec 3 décimales : "+ this.mathRounding(nResult, 3) );
			Out.trace("Arrondi avec 4 décimales : "+ this.mathRounding(nResult, 4) );
			Out.trace("------------------");
		}
		
		
		/**
		 * Création d'un champ texte.
		 * 
		 */
		private function addText(sValue:String) : UITextField
		{
			var oTxtField:UITextField = new UITextField();
			oTxtField.text = sValue;
		
			oTxtField.alignLeft(); // centre le texte
			oTxtField.convertToDynamic(); // centre le texte
			oTxtField.border = true;
			
			oTxtField.maxWidth = oTxtField.width = stage.stageWidth;
			oTxtField.maxHeight = oTxtField.height = 300;
			
			oTxtField.changeFormat("size", 13);// changement de la taille de la police du texte
			oTxtField.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtField.changeFormat("color", 0x006f77);// changement de la couleur
			
			return oTxtField;
		}
		
		
		/**
		 * Arrondi un nombre avec x décimales après la virgule.
		 * 
		 * @param nValue : nombre à arrondir
		 * @param nDecimal : nombre de décimales (par défaut pas d'arrondi, sans décimal)
		 * @return : nombre arrondi
		 */
		private function mathRounding( nValue:Number, nDecimal:int=0) : Number
		{
			// Math.pow pour la puissance de 10 - puissance de 10 en fonction du nombre de décimales souhaitées
			var nMult:Number = Math.pow(10, nDecimal); 
			
			return Math.round( nValue * nMult ) / nMult;
		}
		

	}
}
